import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
public class Engine extends Canvas implements Runnable{
    Thread t;
    Image img;
    Graphics h;
    Polygon start;
    Polygon end;
    PaintGroup pgstart;
    PaintGroup pgend;
    String status="astrosolutions.de";
    boolean first=true;
    boolean ison=false;
    Graphics paintg;
    boolean inverse=false;
    int height=0;
    int width=0;
    int key=0;
    public Engine(){
        img=Image.createImage(800,600);
        h=img.getGraphics();
        height=getHeight();
        width=getWidth();
//        t=new Thread(this);
//        t.start();
    }
    public synchronized void setOn(){
        first=false;
        ison=true;
    }
    public synchronized void setOff(){
        ison=false;
    }
    public synchronized void setInverseOn(){
        inverse=true;
    }
    public synchronized void setInverseOff(){
        inverse=false;
    }
    public synchronized void run(){
//        boolean running=true;
//        try{
//            while(running){
//                Thread.sleep(100);
//                repaint();
//            }
//        }
//        catch(Exception e){
//        }
    }
    public synchronized void setNotProcessed(){
        Polygon cur=start;
        while(cur!=null){
            if(cur.pg!=null){
                cur.pg.setNotProcessed();
            }
            cur=cur.next;
        }
    }
    public synchronized void remove(Polygon poly){
        Polygon fore=null;
        Polygon cur=start;
        while(cur!=null){
            if(cur==poly){
                if(cur.pg!=null){
                    cur.pg.remove(cur);
                }
                if(fore==null){
                    start=cur.next;
                }
                if(cur.next==null){
                    end=fore;
                }
                if(fore!=null){
                    fore.next=cur.next;
                }
            }
            fore=cur;
            cur=cur.next;
        }
    }
    public synchronized void remove(Group g){
        Polygon cur=g.start;
        while(cur!=null){
            remove(cur);
            cur=cur.grnext;
        }
    }
    public synchronized void rotUp(Doubleg w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.next;
        }
    }
    public synchronized void rotLeft(Doubleg w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.next;
        }
    }
    public synchronized void transform(Doubleg a,Doubleg b,Doubleg c){
        Polygon cur=start;
        while(cur!=null){
            cur.transform(a,b,c);
            cur=cur.next;
        }
    }
    public synchronized void getPaintGroups(){
        pgstart=null;
        pgend=null;
        Polygon cur=start;
        while(cur!=null){
            if(cur.pg==null){
                cur.pg=new PaintGroup();
                cur.pg.add(cur);
                cur.pg.setProcessed();
                addPaintGroup(cur.pg);
            }
            else{
                if(!cur.pg.processed){
                    addPaintGroup(cur.pg);
                    cur.pg.setProcessed();
                }
            }
            cur=cur.next;
        }
    }
    public synchronized void addPaintGroup(PaintGroup pg){
        pg.next=null;
        if(pgstart==null){
            pgstart=pg;
            pgend=pg;
        }
        else{
            pgend.next=pg;
            pgend=pgend.next;
        }
    }
    public synchronized void add(Polygon p){
        p.next=null;
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.next=p;
            end=end.next;
        }
    }
    public synchronized void add(Group group){
        Polygon cur=group.start;
        while(cur!=null){
            add(cur);
            cur=cur.grnext;
        }
    }
    public static void sort(PaintGroup[]a,int l,int r){
//Quicksort sortiert PaintGroups nach entf-Werten
        if(l>=r){
            return;
        }
        PaintGroup[]part=new PaintGroup[r-l+1];
        PaintGroup[]partm=new PaintGroup[r-l+1];
        int middle=(l+r)/2;
        Doubleg middlevalue=a[middle].entf;
        int i=0;
        int j=r-l;
        int m=0;
        for(int k=l;k<=r;k++){
            if(a[k].entf.l<middlevalue.l){
                part[i]=a[k];
                i++;
            }
            else if(a[k].entf.l>middlevalue.l){
                part[j]=a[k];
                j--;
            }
            else{
                partm[m]=a[k];
                m++;
            }
        }
        for(int k=0;k<i;k++){
            a[k+l]=part[k];
        }
        for(int k=0;k<m;k++){
            a[i+k+l]=partm[k];
        }
        for(int k=r-l;k>j;k--){
            a[k+l]=part[k];
        }
        sort(a,l,i-1+l);
        sort(a,j+1+l,r);
    }
    public synchronized Vektor getCoord(Vektor v){
        Doubleg x=v.x;
        Doubleg y=v.y;
        Doubleg z=v.z;
        if(x.l==0){
            return new Vektor(new Doubleg(-1),new Doubleg(0),new Doubleg(0));
        }
        Doubleg vx=Tan.atan(y.div(x)).mal(new Doubleg(6*width/2*1000)).div(Sin.PI);
        Doubleg vy=Tan.atan(z.div(x)).mal(new Doubleg(6*width/2*1000)).div(Sin.PI);
        Doubleg vz=x;
        Vektor rvv=new Vektor(vx,vy,vz);
        return rvv;
    }
    protected void keyPressed(int k){
        key=k;
    }
    public int getKey(){
        int r=key;
        key=0;
        return r;
    }
    public synchronized void paint(Graphics g){
        if(first){
            first=false;
            return;
        }
        if(!ison){
            if(paintg!=null){
                paint(paintg);
                return;
            }
        }
        h.setColor(255,255,255);
        h.fillRect(0,0,800,600);
//System.gc();
        setNotProcessed();
        getPaintGroups();
        PaintGroup pgcur=pgstart;
        int count=0;
        while(pgcur!=null){
            pgcur.getEntf();
            pgcur=pgcur.next;
            count++;
        }
        pgcur=pgstart;
        PaintGroup[]pgs=new PaintGroup[count];
        for(int i=0;i<count;i++){
            pgs[i]=pgcur;
            pgcur=pgcur.next;
        }
        sort(pgs,0,pgs.length-1);
        for(int i=pgs.length-1;i>=0;i--){
            Polygon pol=pgs[i].start;
            while(pol!=null){
                Vektor point=pol.start;
                if(pol.kugel){
                    Vektor kv=getCoord(point);
                    if(kv.z.l>0){
                        Doubleg winkel=Tan.atan(pol.radius.div(pgs[i].entf));
                        int len=winkel.mal(new Doubleg(width*1000*6).div(Sin.PI)).getInt();
                        setColor(h,pol.col);
                        if(!inverse){
                            h.fillArc(width/2-(len/2)+((int)kv.x.getInt()),height/2-(len/2)-((int)kv.y.getInt()),len,len,0,360);
                        }
                        else{
                            h.fillArc(width/2-(len/2)+((int)kv.x.getInt()),height/2+(len/2)-((int)kv.y.getInt()),len,len,0,360);
                        }
                    }
                }
                else{
                    Poladd pogy=new Poladd();
                    boolean seen=true;
                    while(point!=null){
                        Vektor veci=getCoord(point);
                        if(veci.z.l<=0){
                            seen=false;
                        }
                        if(!inverse){
                            pogy.addPoint((int)(width/2+veci.x.getInt()),(int)(height/2-veci.y.getInt()));
                        }
                        else{
                            pogy.addPoint((int)(width/2+veci.x.getInt()),(int)(height/2+veci.y.getInt()));
                        }
                        point=point.next;
                    }
                    if(seen){
                        setColor(h,pol.col);
                        h.fillTriangle(pogy.x1,pogy.y1,pogy.x2,pogy.y2,pogy.x3,pogy.y3);
                        if(pol.col.r!=pol.rcol.r||pol.col.g!=pol.rcol.g||pol.col.b!=pol.rcol.b){
                            setColor(h,pol.rcol);
                            h.drawLine(pogy.x1,pogy.y1,pogy.x2,pogy.y2);
                            h.drawLine(pogy.x2,pogy.y2,pogy.x3,pogy.y3);
                            h.drawLine(pogy.x3,pogy.y3,pogy.x1,pogy.y1);
                        }
                    }
                }
                pol=pol.gnext;
            }
        }
        g.drawImage(img,0,0,0);
        paintg=g;
    }
    public synchronized void setStatus(String status){
        this.status=status;
    }
    public synchronized void setColor(Graphics h,Color col){
        h.setColor(col.r,col.g,col.b);
    }
}
class Poladd{
    int x1=0;
    int y1=0;
    int x2=0;
    int y2=0;
    int x3=0;
    int y3=0;
    int c=0;
    public Poladd(){
    }
    public void addPoint(int x,int y){
        if(c==0){
            x1=x;
            y1=y;
        }
        if(c==1){
            x2=x;
            y2=y;
        }
        if(c==2){
            x3=x;
            y3=y;
        }
        c++;
    }
}
class PaintGroup{
    PaintGroup next;
    Polygon start;
    Polygon end;
    boolean processed=false;
    Doubleg entf=new Doubleg(0);
    public PaintGroup(){
    }
    public void getEntf(){
        entf=entf();
    }
    public void setProcessed(){
        processed=true;
    }
    public void setNotProcessed(){
        processed=false;
    }
    public void reset(){
        start=null;
        end=null;
    }
    public void remove(Polygon poly){
        Polygon fore=null;
        Polygon cur=start;
        while(cur!=null){
            if(cur==poly){
                if(fore==null){
                    start=cur.gnext;
                }
                if(cur.gnext==null){
                    end=fore;
                }
                if(fore!=null){
                    fore.gnext=cur.gnext;
                }
            }
            fore=cur;
            cur=cur.gnext;
        }
    }
    public void add(Polygon p){
        p.gnext=null;
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.gnext=p;
            end=end.gnext;
        }
    }
    public Doubleg entf(){
        int count=0;
        Polygon cur=start;
        Vektor sum=new Vektor(new Doubleg(0),new Doubleg(0),new Doubleg(0));
        while(cur!=null){
            Vektor cur2=cur.start;
            while(cur2!=null){
                sum.transform(cur2.getX(),cur2.getY(),cur2.getZ());
                cur2=cur2.next;
                count++;
            }
            cur=cur.gnext;
        }
        Vektor ret=new Vektor(sum.x.div(new Doubleg(count*1000)),sum.y.div(new Doubleg(count*1000)),sum.z.div(new Doubleg(count*1000)));
        return ret.entf();
    }
}
class Group{
    Polygon start;
    Polygon end;
    public Group cloneo(){
        Group group=new Group();
        Polygon cur=start;
        while(cur!=null){
            group.add(cur.cloneo());
            cur=cur.grnext;
        }
        return group;
    }
    public void add(Polygon p){
        p.grnext=null;
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.grnext=p;
            end=end.grnext;
        }
    }
    public void rotUp(Doubleg w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.grnext;
        }
    }
    public void rotLeft(Doubleg w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.grnext;
        }
    }
    public void transform(Doubleg a,Doubleg b,Doubleg c){
        Polygon cur=start;
        while(cur!=null){
            cur.transform(a,b,c);
            cur=cur.grnext;
        }
    }
}
class Kugel extends Polygon{
    public Kugel(Color col,Color rcol,Vektor v,Doubleg radius){
        super(col,rcol);
        add(v);
        this.radius=radius;
        this.kugel=true;
    }
    public Vektor getCenter(){
        return start;
    }
}
class Quad extends Polygon{
    public Quad(Color col,Color rcol,Vektor v1,Vektor v2,Vektor v3,Vektor v4){
        super(col,rcol);
        add(v1);
        add(v2);
        add(v3);
        add(v4);
    }
    public Vektor getV1(){
        return start;
    }
    public Vektor getV2(){
        return start.next;
    }
    public Vektor getV3(){
        return start.next.next;
    }
    public Vektor getV4(){
        return start.next.next.next;
    }
}
class Triangle extends Polygon{
    public Triangle(Color col,Color rcol,Vektor v1,Vektor v2,Vektor v3){
        super(col,rcol);
        add(v1);
        add(v2);
        add(v3);
    }
    public Vektor getV1(){
        return start;
    }
    public Vektor getV2(){
        return start.next;
    }
    public Vektor getV3(){
        return start.next.next;
    }
}
class Polygon{
    Polygon next;
    Polygon gnext;
    Polygon grnext;
    PaintGroup pg;
    Vektor start;
    Vektor end;
    Color col;
    Color rcol;
    boolean kugel=false;
    Doubleg radius=new Doubleg(0);
    boolean processed=false;
    Doubleg entf=new Doubleg(0);
    public Polygon(Color col,Color rcol){
        this.col=col;
        this.rcol=rcol;
    }
    public Polygon cloneo(){
        Polygon ret=new Polygon(col,rcol);
        ret.kugel=kugel;
        ret.radius=radius;
        ret.processed=processed;
        ret.entf=entf;
        Vektor cur=start;
        while(cur!=null){
            ret.add(cur.cloneo());
            cur=cur.next;
        }
        return ret;
    }
    public void setProcessed(){
        processed=true;
    }
    public void setNotProcessed(){
        processed=false;
    }
    public void setPaintGroup(PaintGroup pg){
        this.pg=pg;
        pg.add(this);
    }
    public void add(Vektor v){
        if(start==null){
            start=v;
            end=v;
        }
        else{
            end.next=v;
            end=end.next;
        }
    }
    public void rotUp(Doubleg w){
        Vektor cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.next;
        }
    }
    public void rotLeft(Doubleg w){
        Vektor cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.next;
        }
    }
    public Doubleg entf(){
        int count=0;
        Vektor cur=start;
        Vektor sum=new Vektor(new Doubleg(0),new Doubleg(0),new Doubleg(0));
        while(cur!=null){
            sum.transform(cur.getX(),cur.getY(),cur.getZ());
            cur=cur.next;
            count++;
        }
        Vektor ret=new Vektor(sum.x.div(new Doubleg(count*1000)),sum.y.div(new Doubleg(count*1000)),sum.z.div(new Doubleg(count*1000)));
        return ret.entf();
    }
    public void transform(Doubleg a,Doubleg b,Doubleg c){
        Vektor cur=start;
        while(cur!=null){
            cur.transform(a,b,c);
            cur=cur.next;
        }
    }
}
class Vektor{
    Doubleg x,y,z;
    Doubleg xtra;
    Vektor next;
    public Vektor(Doubleg x,Doubleg y,Doubleg z){
        this.x=x;
        this.y=y;
        this.z=z;
    }
    public void print(){
//        System.out.println("x: "+x+" y: "+y+" z: "+z);
    }
    public Doubleg getX(){
        return x;
    }
    public Doubleg getY(){
        return y;
    }
    public Doubleg getZ(){
        return z;
    }
    public Doubleg getXtra(){
        return xtra;
    }
    public Vektor cloneo(){
        Vektor cl=new Vektor(x.cloneo(),y.cloneo(),z.cloneo());
        if(xtra!=null)cl.xtra=xtra.cloneo();
        return cl;
    }
    public void transform(Doubleg a,Doubleg b,Doubleg c){
        x=x.add(a);
        y=y.add(b);
        z=z.add(c);
    }
    public void setCoord(int coord,Doubleg a){
        if(coord==1)x=a;
        else if(coord==2)y=a;
        else if(coord==3)z=a;
    }
    public void changeCoord(int coord1,int coord2){
        Doubleg temp=null;
        if((coord1==1&&coord2==2)||(coord1==2&&coord2==1)){
            temp=x;
            x=y;
            y=temp;
        }
        if((coord1==1&&coord2==3)||(coord1==3&&coord2==1)){
            temp=x;
            x=z;
            z=temp;
        }
        if((coord1==2&&coord2==3)||(coord1==3&&coord2==1)){
            temp=y;
            y=z;
            z=temp;
        }
    }
    public Doubleg entf(){
        Doubleg sq=x.mal(x).add(y.mal(y)).add(z.mal(z));
        return Doubleg.sqrt(sq);
    }
    public void rotLeft(Doubleg w){
        Doubleg win=new Doubleg(0);
        if(x.l==0){
            if(y.l>0)win=Sin.PI.div(new Doubleg(2000));
            else win=Sin.PI.div(new Doubleg(-2000));
        }
        else{
            win=Tan.atan(y.div(x));
        }
        if(x.l<0)win=win.add(Sin.PI);
        Doubleg len=Doubleg.sqrt(x.mal(x).add(y.mal(y)));
        win=win.add(w);
        x=Cos.cos(win).mal(len);
        y=Sin.sin(win).mal(len);
    }
    public void rotUp(Doubleg w){
        Doubleg win=new Doubleg(0);
        if(x.l==0){
            if(z.l>0)win=Sin.PI.div(new Doubleg(2000));
            else win=Sin.PI.div(new Doubleg(-2000));
        }
        else{
            win=Tan.atan(z.div(x));
        }
        if(x.l<0)win=win.add(Sin.PI);
        Doubleg len=Doubleg.sqrt(x.mal(x).add(z.mal(z)));
        win=win.add(w);
        x=Cos.cos(win).mal(len);
        z=Sin.sin(win).mal(len);
    }
}
class Color{
    int r=0;
    int g=0;
    int b=0;
    public Color(int r,int g,int b){
        this.r=r;
        this.g=g;
        this.b=b;
    }
}
